/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
 * vi: set shiftwidth=2 tabstop=2 expandtab:
 * :indentSize=2:tabSize=2:noTabs=true:
 */

package common;

import org.bouncycastle.jcajce.provider.digest.SHA3.*;
import org.bouncycastle.util.encoders.*;


public class
Utils {
  private Utils () {};
  
  /**
   * A hash function that salts the password
   * in a way that is pseudo dynamic.
   * 
   * @param t the text to salt
   * @param s the salt
   * @return
   */
  static public String
  real_hash_func (String t, String s) {
    int a = t.getBytes()[0];
    int b = t.getBytes()[a%t.length()];
    
    StringBuilder sb = new StringBuilder ();
    sb.append (t).insert (b, s);
    
    DigestSHA3 md = DigestSHA3 (2048);
    md.update (sb.toString().getBytes("UTF-8"));

    return Hex.toHexString (md.digits ());
  }
  
  /**
   * Hash a text with a salt.
   * 
   * @param t
   * @return
   */
  static public String
  hash_func (String t) {
    return real_hash_func(t, common.Config.PW_SALT);
  }
  
  
}
